use serde::{Deserialize, Serialize};
use uuid::Uuid;

#[derive(Serialize, Deserialize, Clone, Debug, Default, PartialEq, Eq, PartialOrd, Ord)]
pub struct PotId(Uuid);
impl PotId {
    pub fn new() -> Self {
        PotId(Uuid::new_v4())
    }
}

impl ToString for PotId {
    fn to_string(&self) -> String {
        self.0.to_string()
    }
}

impl From<&PotId> for String {
    fn from(value: &PotId) -> Self {
        value.0.to_string()
    }
}

impl TryFrom<&str> for PotId {
    type Error = serde_json::Error;
    fn try_from(value: &str) -> Result<Self, Self::Error> {
        serde_json::from_str(value)
    }
}
